︠744332b1-6cdb-4f3d-a6c1-e4cd83d6bf98asi︠
%hide
%auto
DATA="foo.data/"
︡07ccc52f-8ac3-41a3-af3f-79ac55f059d7︡{"auto":true}︡
︠4515280f-cb56-4f00-8655-32732136b083i︠
%html
<h1>Measuring the Price of Anarchy in CCU Interactions.</h1>
<p>(Knight,&nbsp;Komenda, Griffiths)</p>
<p>This worksheet contains code used to obtain the graphics for the paper entitled: 'Measuring the Price of Anarchy in CCU Interaction'.</p>
<p>The abstract of the paper is:</p>
<p><em>"Hospital throughput is often studied and optimised in isolation, ignoring the interactions between hospitals. In this&nbsp;paper Critical Care Unit (CCU) interaction is placed within a game theoretic framework. The methodology involves&nbsp;the use of a normal form game underpinned by a two dimensional continuous Markov chain. A theoretical result is&nbsp;given that ensures the existence of a Nash equilibrium.</em></p>
<p><em>The effect of target policies is investigated justifying the use of these to align the interests of individual hospitals&nbsp;and social welfare. In particular, we identify the lowest value of a utilisation target that aligns these."</em></p>
<h1>Best response for t=.8</h1>

︡3d999df2-6f8d-459f-bc39-5ffe7c3da363︡{"html": "<h1>Measuring the Price of Anarchy in CCU Interactions.</h1>\n<p>(Knight,&nbsp;Komenda, Griffiths)</p>\n<p>This worksheet contains code used to obtain the graphics for the paper entitled: 'Measuring the Price of Anarchy in CCU Interaction'.</p>\n<p>The abstract of the paper is:</p>\n<p><em>\"Hospital throughput is often studied and optimised in isolation, ignoring the interactions between hospitals. In this&nbsp;paper Critical Care Unit (CCU) interaction is placed within a game theoretic framework. The methodology involves&nbsp;the use of a normal form game underpinned by a two dimensional continuous Markov chain. A theoretical result is&nbsp;given that ensures the existence of a Nash equilibrium.</em></p>\n<p><em>The effect of target policies is investigated justifying the use of these to align the interests of individual hospitals&nbsp;and social welfare. In particular, we identify the lowest value of a utilisation target that aligns these.\"</em></p>\n<h1>Best response for t=.8</h1>"}︡
︠afafa9d7-c9b2-4482-b1d5-656e4cc17e4es︠
NHbr = [[0, 7],
 [1, 7],
 [2, 7],
 [3, 7],
 [4, 7],
 [5, 8],
 [6, 8],
 [7, 8],
 [8, 8],
 [9, 8],
 [10, 8],
 [11, 8],
 [12, 8],
 [13, 8],
 [14, 8],
 [15, 8],
 [16, 8]]
RGbr = [[14, 0],
 [15, 1],
 [15, 2],
 [16, 3],
 [16, 4],
 [16, 5],
 [16, 6],
 [16, 7],
 [16, 8]]
p = list_plot(NHbr, plotjoined=True, linestyle='', marker='D', legend_label='Best response to RG', color='grey', ticks=[range(1,17),range(1,9)])
p += list_plot(RGbr, plotjoined=True, linestyle='', marker='x', color='black', legend_label='Best response to NH')
p += circle([16,8],.25)
p.axes_labels(['$K_{RG}$', '$K_{NH}$'])
p.set_legend_options(loc=[.1,.1])
p.axes_labels_size(3)
p.save('best_responses_model1.pdf')
p
︡6a3f514c-5898-4512-a6ce-e4a87ba25ac1︡︡{"file":{"filename":"/projects/c293aefd-1fdf-4b9c-95f4-75bb77035e42/.sage/temp/compute1-us/19649/tmp_djxxrV.svg","show":true,"uuid":"9c6ad612-7e32-4a0d-9360-74aa4e09ecc2"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠d227f0cc-0960-46f7-93bd-6db13080446ai︠
%html
<h1>Best response graph for t=.6</h1>

︡1afff70d-ac4d-49ad-82ab-c4f3f6d1717a︡{"html":"<h1>Best response graph for t=.6</h1>\n\n"}︡
︠f2460419-a7c3-4c7e-9aa8-a78980c4de89s︠
NHbr = [[0, 5],
 [1, 5],
 [2, 5],
 [3, 5],
 [4, 5],
 [5, 6],
 [6, 6],
 [7, 6],
 [8, 6],
 [9, 6],
 [10, 6],
 [11, 6],
 [12, 6],
 [13, 6],
 [14, 6],
 [15, 7],
 [16, 7]]
RGbr = [[10, 0],
 [11, 1],
 [11, 2],
 [11, 3],
 [11, 4],
 [11, 5],
 [11, 6],
 [12, 7],
 [12, 8]]
p = list_plot(NHbr, plotjoined=True, linestyle='', marker='D', legend_label='Best response to RG', color='grey', ticks=[range(1,17),range(1,9)])
p += list_plot(RGbr, plotjoined=True, linestyle='', marker='x', color='black', legend_label='Best response to NH')
p += circle([11,6],.25)
p.axes_labels(['$K_{RG}$', '$K_{NH}$'])
p.set_legend_options(loc=[.1,.1])
p.axes_labels_size(3)
p.save('best_responses_model1_t=0_6.pdf')
p
︡e60dbb61-b8d7-4091-bdea-0b2d1bf654e7︡︡{"file":{"filename":"/projects/c293aefd-1fdf-4b9c-95f4-75bb77035e42/.sage/temp/compute1-us/19649/tmp__GCkwS.svg","show":true,"uuid":"8e61d827-4c39-48a6-a87c-7c34313e9590"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠f99edb55-8866-486d-9e73-9fecad95f62fi︠
%html
<h1>Function to plot heatmap</h1>

︡6315ed84-1abf-48a3-b3ec-9014605c6748︡{"html":"<h1>Function to plot heatmap</h1>\n\n"}︡
︠c3a79585-a761-414f-b349-ef26b0696dfas︠
import matplotlib.pyplot as plt
import numpy as np
from matplotlib import cm
from numpy.random import randn
from pylab import cm, get_cmap

def cmap_map(function,cmap):
    """ Applies function (which should operate on vectors of shape 3:
    [r, g, b], on colormap cmap. This routine will break any discontinuous     points in a colormap.
    """
    cdict = cmap._segmentdata
    step_dict = {}
    # Firt get the list of points where the segments start or end
    for key in ('red','green','blue'):         step_dict[key] = map(lambda x: x[0], cdict[key])
    step_list = sum(step_dict.values(), [])
    step_list = array(list(set(step_list)))
    # Then compute the LUT, and apply the function to the LUT
    reduced_cmap = lambda step : array(cmap(step)[0:3])
    old_LUT = array(map( reduced_cmap, step_list))
    new_LUT = array(map( function, old_LUT))
    # Now try to make a minimal segment definition of the new LUT
    cdict = {}
    for i,key in enumerate(('red','green','blue')):
        this_cdict = {}
        for j,step in enumerate(step_list):
            if step in step_dict[key]:
                this_cdict[step] = new_LUT[j,i]
            elif new_LUT[j,i]!=old_LUT[j,i]:
                this_cdict[step] = new_LUT[j,i]
        colorvector=  map(lambda x: x + (x[1], ), this_cdict.items())
        colorvector.sort()
        cdict[key] = colorvector

    return matplotlib.colors.LinearSegmentedColormap('colormap',cdict,1024)

def makedict(lst):
    d = {}
    for row in lst:
        if row[0] in d:
            d[row[0]][row[1]] = row[2]
        else:
            d[row[0]] = {row[1] : row[2]}
    return d

def makematrix(lst):
    d = makedict(lst)
    xset = sorted(list(set(([k[0] for k in lst]))))
    yset = sorted(list(set(([k[1] for k in lst]))))
    m = len(xset)
    n = len(yset)
    M = matrix(RR, m, n)
    indexdict = {}
    for i in range(m):
        for j in range(n):
            if xset[i] in d:
                if yset[j] in d[xset[i]]:
                    M[i, j] = d[xset[i]][yset[j]]
    return M

def heatplot(lst, title='heatplot.pdf', xlabel='$x$', ylabel='$y$', titlelabel=False, redoticks=True, incrementticks=False, clr='gist_yarg',cbticks=False,cblabels=False):
    fig, ax = plt.subplots()

    xvalues = [row[1] for row in lst]
    yvalues = [row[0] for row in lst]
    xmin = min(xvalues)
    xmax = max(xvalues)
    ymin = min(yvalues)
    ymax = max(yvalues)

    data = makematrix(lst)

    cax = ax.imshow(data, interpolation='nearest', cmap=get_cmap(clr), aspect='auto')
    if titlelabel:
        ax.set_title(titlelabel, fontsize="xx-large")

    cbar = fig.colorbar(cax)
    if cbticks:
        cbar.set_ticks(cbticks)
    if cblabels:
        cbar.set_ticklabels(cblabels)
    if redoticks:
        nbrxlabels = len(plt.xticks()[0])
        xlabs = srange(xmin, xmax, (xmax - xmin) / nbrxlabels)

        nbrylabels =len(plt.yticks()[0])
        ylabs = srange(ymin, ymax, (ymax - ymin) / (nbrylabels))

        ax.set_xticklabels([round(x,2) for x in xlabs])
        ax.set_yticklabels([round(y,2) for y in ylabs])


        ax.set_xticks(srange(0, max(plt.xticks()[0]), max(plt.xticks()[0])/nbrxlabels))
        ax.set_yticks(srange(0, max(plt.yticks()[0]), max(plt.yticks()[0])/nbrylabels))

    if incrementticks:
        xlabs = plt.xticks()[0]

        ylabs = plt.yticks()[0]

        ax.set_xticklabels([int(x + incrementticks) for x in xlabs])
        ax.set_yticklabels([int(y + incrementticks) for y in ylabs])

    plt.ylabel(xlabel, fontsize="x-large")
    plt.xlabel(ylabel, fontsize="x-large")
    plt.savefig(title)
︡619c87f2-2c77-4e56-a33b-02020d2830cd︡︡{"done":true}
︠0acbf872-f70a-417c-a840-f5dd3fac3581i︠
%html
<h1>Model 1</h1>

<h2>PoA</h2>

︡a62bac67-83bb-423a-99af-ee23f935fd91︡{"html":"<h1>Model 1</h1>\n\n<h2>PoA</h2>\n\n"}︡
︠8d138533-a05d-46cb-b666-2c44d70c577fs︠
import csv
DATA = 'foo.data/'
f = open(DATA+'M1_target_demand', 'r')
data = csv.reader(f)
data = [row for row in data]
f.close()
data = [[round(eval(k),2) for k in row] for row in data[1:]]
︡b937cfde-8666-4096-937d-bbc0e66ad3cc︡︡{"done":true}
︠8eee040c-2ee4-42c9-b9e4-ec8480a562efs︠
heatplot([[row[0], row[1], ln(row[2])] for row in data if row[0] >= .1 and row[2] != +infinity], title='lnPoAmodel1targetvdemand.pdf', xlabel='$t$', ylabel='$x$', titlelabel='PoA',cbticks=[0,.25,.5,.75,1,1.25,1.5,1.75,2], cblabels=["%.01f" % e^x for x in [0,.25,.5,.75,1,1.25,1.5,1.75,2]])
︡51f2bbc9-c8f2-4276-9923-5455213e2c79︡︡{"done":true}
︠2136c55f-4af2-407a-9ea6-bef758fb40e3s︠
heatplot([row for row in data if row[0] < .4], title='model1targetvdemandfort<4.pdf', xlabel='$t$', ylabel='$x$', titlelabel='PoA')
︡429eed86-c789-45e9-9601-fa506b732474︡︡{"done":true}
︠43d03d51-a43b-4cdc-8a56-262bec0b7ac5s︠
heatplot([row for row in data if row[0] > .25], title='model1targetvdemandfort>25.pdf', xlabel='$t$', ylabel='$x$', titlelabel='PoA')
︡35af6b88-6111-4c79-9b03-6da1286a6d46︡︡{"done":true}
︠063d9fe3-3cfd-464b-9e94-de0e0ffcd9dcs︠
heatplot([row for row in data if row[0] > .5], title='model1targetvdemandfort>5.pdf', xlabel='$t$', ylabel='$x$', titlelabel='PoA')
︡afa3889c-94f1-4752-8cae-c92d3db58b1a︡︡{"done":true}
︠0118d039-634a-4d38-8e26-86e8203349f8i︠
%html
<h2>Lowest target for PoA = 1</h2>

︡5b127990-0a65-4af3-bfb0-fdc4bdebb086︡{"html":"<h2>Lowest target for PoA = 1</h2>\n\n"}︡
︠094e3afe-dd8a-4d2a-921a-2b3695e5fe66s︠
def PoAvxdict(lst):
    d = {}
    for row in lst:
        if row[1] in d:
            d[row[1]][row[0]] = row[2]
        else:
            d[row[1]] = {row[0] : row[2]}
    return d

def plotmint(lst):
    l = []
    d = PoAvxdict(lst)
    for x in d:
        minPoA = min([d[x][k] for k in d[x]])
        l.append([x, min([k for k in d[x] if d[x][k] == minPoA])])
    return list_plot(l, size=30, color='black')
︡086e4563-5e21-48c0-ba99-dfbb4f21ccff︡︡{"done":true}
︠574c7c11-3ea4-4281-a0af-077c17ce3a28s︠
p = plotmint(data)
p.axes_labels(['$x$', 'argmin$_t($PoA$(x))$'])
p.ymin(0)
p.ymax(1)
p.axes_labels_size(2)
p.save('argminPoAmodel1.pdf')
p
︡cfc8c74c-8d7a-4979-a14c-dd0389ce6baf︡︡{"file":{"filename":"/projects/c293aefd-1fdf-4b9c-95f4-75bb77035e42/.sage/temp/compute1-us/19649/tmp_rEXMP_.svg","show":true,"uuid":"4dfcbec6-ac9f-474f-baab-79815b185437"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠31df237c-3e1a-4985-b003-3b98295e95fbi︠
%html
<h2>Model 2</h2>

︡c514f521-322f-4e3e-be34-b298ddfcaa09︡{"html":"<h2>Model 2</h2>\n\n"}︡
︠66845f6c-d768-47fa-b8aa-31958b03c0e0s︠
import csv
f = open(DATA+'M2_target_demand', 'r')
data = csv.reader(f)
data = [row for row in data]
f.close()
data = [[round(eval(k),2) for k in row] for row in data[1:]]
︡5896d1df-9d6f-4573-a966-6902afa15b61︡︡{"done":true}
︠6d2adb03-90b5-4af5-9730-f4a86c7b3561s︠
heatplot([[row[0], row[1], row[2]] for row in data if row[0] >= .1 and row[2] != +infinity], title='model2targetvdemand.pdf', xlabel='$t$', ylabel='$x$', titlelabel='PoA')
︡5eafb596-49f2-4535-9fe4-f9a672a3e3bd︡︡{"done":true}
︠f51fef6d-bb0f-44fb-8968-d31171c97f6fs︠
p = plotmint(data)
p.axes_labels(['$x$', 'argmin$_t($PoA$(x))$'])
p.ymin(0)
p.ymax(1)
p.axes_labels_size(2)
p.save('argminPoAmodel2.pdf')
p
︡8af2baba-baf5-4cc1-a64e-f5c0ea5d3ac7︡︡{"file":{"filename":"/projects/c293aefd-1fdf-4b9c-95f4-75bb77035e42/.sage/temp/compute1-us/26764/tmp_wucRHq.svg","show":true,"uuid":"a50279fc-8649-4fd3-9462-9baa870352a5"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠76ad0b4b-3323-4bf6-84f2-29bae828dafci︠
%html
<h1>Capacity Plots</h1>

︡a5cdea0f-e1d3-48e6-b47f-c267fe826967︡{"html":"<h1>Capacity Plots</h1>\n\n"}︡
︠d88c6364-2562-4034-b812-87c231939e34s︠
import csv
f = open(DATA+'M1_capacity', 'r')
data = csv.reader(f)
data = [row for row in data]
f.close()
FALSE = False
data = [[round(eval(k),2) for k in row] for row in data[1:]]
data = [row for row in data if row[0]>1 and row[1]>1]
︡d3806e84-a54e-49db-ad34-7c41bc6738d5︡︡{"done":true}
︠f495be62-5c20-4bda-ae47-6fdfdf808129s︠
heatplot([row for row in data if row[1]<22], title='model1capacity.pdf', xlabel='$c_{NH}$', ylabel='$c_{RG}$', titlelabel='PoA', redoticks=False, incrementticks = 2)
︡7cbb61fb-64d4-4bbf-b0a8-65c382526daf︡︡{"done":true}
︠114c28c9-de04-4235-8ff6-cb3e35ae2eb9s︠
import csv
f = open(DATA+'M2_capacity', 'r')
data = csv.reader(f)
data = [row for row in data]
f.close()
data = [[round(eval(k),2) for k in row] for row in data[1:]]
data = [row for row in data if row[0]>1 and row[1]>1]
︡25e10b75-c9ec-4933-81cd-0ac069fd2101︡︡{"done":true}
︠ad6e9539-7988-4be1-b4db-66c982892ed8s︠
heatplot([row for row in data if row[1]<22], title='model2capacity.pdf', xlabel='$c_{NH}$', ylabel='$c_{RG}$', titlelabel='PoA', redoticks=False, incrementticks = 2)
︡9ff55bc4-2c3a-4e18-be5c-0a37c7c870da︡︡{"done":true}
︠46fea8d2-1961-4adc-b98e-2857d4573c31i︠
%html
<h1>Steady state probabilities</h1>

︡2fdf85dd-4626-41ee-ad23-20f8fc406ea1︡{"html":"<h1>Steady state probabilities</h1>\n\n"}︡
︠8326e16f-1bf5-488c-ae9d-2c561e714d67s︠
NH = [0.0024678535857431323,
 0.015726290629619416,
 0.05091770938993938,
 0.11226713892826898,
 0.19131907048179278,
 0.27338253952862523,
 0.3539193974560111,
 0.0,
 0.0]
RG =  [6.429788681200632e-06,
 7.867929699401477e-05,
 0.0004834366461007307,
 0.0019895883556981793,
 0.006173269294301033,
 0.015414004918794444,
 0.03229069468890144,
 0.0584485711739349,
 0.09349055513077142,
 0.13464969759037496,
 0.1777308502600037,
 0.21930666447309408,
 0.2599375583823499,
 0.0,
 0.0,
 0.0,
 0.0]
︡7f12df06-55b4-4c56-971c-d5bcf7697891︡︡{"done":true}
︠01ab6dda-d010-4bb8-b056-952571227314s︠
p = list_plot(NH, size=40, axes_labels=['$n$', '$P(n)$'], color='black',ticks=[range(1,9),[0,.2,.4,.6,.8,1]])
p += line([[6,0], [6,1]], color='red', linestyle='dashed')
p += text('$K_{NH}$',(6.2,1.02), color='black', fontsize=20)
p.ymax(1)
p.axes_labels_size(2)
p.save('NH.pdf')
p
︡edff2f9c-bc67-4971-b82e-30faaad2baa6︡︡{"file":{"filename":"/projects/c293aefd-1fdf-4b9c-95f4-75bb77035e42/.sage/temp/compute1-us/26764/tmp_NkBmuX.svg","show":true,"uuid":"a73c62ee-90c4-4614-8843-d9d62fb94021"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠41738e0d-ba01-4c67-aeec-513f8293ba8bs︠
p = list_plot(RG, size=40, axes_labels=['$n$', '$P(n)$'], color='black', ticks=[range(1,17),[0,.2,.4,.6,.8,1]])
p += line([[12,0], [12,1]], color='red', linestyle='dashed')
p += text('$K_{RG}$',(12.5,1.02), color='black', fontsize=20)
p.ymax(1)
p.axes_labels_size(2)
p.save('RG.pdf')
p
︡a6b87065-3770-4a76-ac44-f851862364e4︡︡{"file":{"filename":"/projects/c293aefd-1fdf-4b9c-95f4-75bb77035e42/.sage/temp/compute1-us/26764/tmp__UdR2f.svg","show":true,"uuid":"08db85bf-c1c0-4503-916a-362ff5559a49"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠b6425937-25e0-421e-8309-eda8175e2dc0s︠
NH = [0.11446786319342364, 0.8855321368065764, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
RG = [2.846728005972963e-07,
 4.723444806693106e-06,
 3.943074788857625e-05,
 0.00022076875718588,
 0.0009325224253835039,
 0.003169530627486097,
 0.009029855901531656,
 0.02218313581230128,
 0.047989623116679016,
 0.09294363028933814,
 0.16338141261963893,
 0.26387851375924976,
 0.39622656782570986,
 0.0,
 0.0,
 0.0,
 0.0]
︡0b48a858-c263-48d1-b42c-5f5be4f7693f︡︡{"done":true}
︠9a74712e-cf37-4caf-a131-1e6b367caa12s︠
p = list_plot(NH, size=40, axes_labels=['$n$', '$P(n)$'], color='black',ticks=[range(1,9),[0,.2,.4,.6,.8,1]])
p += line([[1,0], [1,1]], color='red', linestyle='dashed')
p += text('$K_{NH}$',(1.2,1.02), color='black', fontsize=20)
p.ymax(1)
p.axes_labels_size(2)
p.save('NH_1_12.pdf')
p
︡ff649587-4858-4686-bf84-86f2c89463a5︡︡{"file":{"filename":"/projects/c293aefd-1fdf-4b9c-95f4-75bb77035e42/.sage/temp/compute1-us/26764/tmp_catxtM.svg","show":true,"uuid":"d51819e6-83c3-47be-bd05-0392aefc68ee"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠b5f5d09d-b81b-4418-a9b4-313f054bd480s︠
p = list_plot(RG, size=40, axes_labels=['$n$', '$P(n)$'], color='black', ticks=[range(1,17),[0,.2,.4,.6,.8,1]])
p += line([[12,0], [12,1]], color='red', linestyle='dashed')
p += text('$K_{RG}$',(12.5,1.02), color='black', fontsize=20)
p.ymax(1)
p.axes_labels_size(2)
p.save('RG_1_12.pdf')
p
︡5d281cda-556b-489d-971b-32d3890ee581︡︡{"file":{"filename":"/projects/c293aefd-1fdf-4b9c-95f4-75bb77035e42/.sage/temp/compute1-us/26764/tmp_Nb75gd.svg","show":true,"uuid":"5ce497fe-38dc-4c43-aa32-791d29c83760"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠a4d5e97f-95cc-489c-ab16-0e38c6ac6ccfi︠
%html
<h1>Example for Proof</h1>

︡77dec897-38c2-4d2a-bbfe-66a0009a730b︡{"html":"<h1>Example for Proof</h1>\n\n"}︡
︠f629c5ff-72dc-4335-ba3e-238ea9433ed1s︠
NHbr = [[0, 2], [1, 4], [2, 4], [3, 4], [4, 4], [5, 5], [6, 5], [7, 5], [8, 5], [9, 5], [10, 6], [11, 6], [12, 6], [13, 7], [14, 7], [15, 8], [16, 8]]
RGbr = [[6, 0], [6, 1], [7, 2], [7, 3], [7, 4], [8, 5], [8, 6], [8, 7], [8, 8]]
p = list_plot(NHbr, plotjoined=True, linestyle='', marker='D', color='grey', ticks=[range(1,17),range(1,9)])
p.ymin(0)
p.ymax(8)
p.axes_labels(['$K_{RG}$', '$K_{NH}$'])
p.axes_labels_size(2)
p.save('best_responses_ex_for_proof_NH.pdf')
p
︡04ae59fc-9b41-4ea1-9217-63a06604f958︡︡{"file":{"filename":"/projects/c293aefd-1fdf-4b9c-95f4-75bb77035e42/.sage/temp/compute1-us/26764/tmp_DX2wVi.svg","show":true,"uuid":"48d5fc46-261a-4ed2-88a4-7df2e7e910e1"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠a98ddc3b-89d2-4155-a401-3e1a82979e68s︠
q = list_plot(RGbr, plotjoined=True, linestyle='',marker='x', color='black', ticks=[range(1,17),range(1,9)])
q.xmax(16)
q.xmin(0)
q.axes_labels(['$K_{RG}$', '$K_{NH}$'])
p.axes_labels_size(3)
q.save('best_responses_ex_for_proof_RG.pdf')
q
︡63bd67a6-3af8-4e35-92d4-570f0d884fd1︡︡{"file":{"filename":"/projects/c293aefd-1fdf-4b9c-95f4-75bb77035e42/.sage/temp/compute1-us/26764/tmp_AUPMjc.svg","show":true,"uuid":"785525d9-f07b-461c-8dda-2f7414bde66b"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠a35858d9-2336-44d4-b7be-d237e6aa2eb0s︠
p = p+q
p += circle([8,5],.25)
p.axes_labels(['$K_{RG}$', '$K_{NH}$'])
p.set_legend_options(loc=[.1,.1])
p.axes_labels_size(2)
p.save('best_responses_ex_for_proof.pdf')
p
︡199dab4b-9c53-4763-9719-557aff55771d︡︡{"file":{"filename":"/projects/c293aefd-1fdf-4b9c-95f4-75bb77035e42/.sage/temp/compute1-us/26764/tmp_GCK5pP.svg","show":true,"uuid":"4d893dff-166a-4ad0-996b-4c71ea5124dd"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠fc65d8c2-10f6-4830-ae18-d2494b9f789fi︠
%html
<h1>Picture for proof</h1>

︡38aa72f8-3cb9-40b9-bbde-bc20af0e7004︡{"html":"<h1>Picture for proof</h1>\n\n"}︡
︠b70f3c0c-c745-46fe-9d69-8b322e9be90ds︠
m = [[1, .9], [2, .75], [3, .65], [4, .58], [5, .55], [6, .52], [7, .49], [8, .47], [9, .45], [10, .44]]
mminusone = [[row[0], row[1] -  .1*row[1]] for row in m]
mplusone = [[row[0], min(row[1] + .25*row[1],1)] for row in m]
mplustwo = [[row[0], min(row[1] + .15*row[1],1)] for row in mplusone]

p = list_plot(mplustwo, plotjoined=True, linestyle='',marker='^', color='black', legend_label='$K_{NH}=m+2$')
p += list_plot(mplusone, plotjoined=True, linestyle='',marker='x', color='black', legend_label='$K_{NH}=m+1$', ticks=[range(11),[.1,.2,.3,.4,.5,.6,.7,.8,.9,1]])
p += list_plot(m, plotjoined=True, linestyle='',marker='D', color='black', legend_label='$K_{NH}=m$')
p += list_plot(mminusone, plotjoined=True, linestyle='',marker='o', color='black', legend_label='$K_{NH}=m-1$')

p += line([[0,.7],[10,.7]], linestyle='dashed', color='red')
p += text('$t$', [10,.71], color='black')

locn = [4, 1]
p += line([[3,0],[3,.65]], linestyle='dashed', color='blue')
p += arrow(vector(locn) - vector([0,.025]),[3.05,.66], color='black')
p += text('$f_{NH}(3)=m$',locn, color='black')

locn = [4.65,.95]
p += line([[4,0],[4,.73]], linestyle='dashed', color='blue')
p += arrow(vector(locn) - vector([0,.025]),[4.05,.74], color='black')
p += text('$f_{NH}(4)=m+1$', locn, color='black')

locn = [5.55, .9]
p += line([[5,0],[5,.55*1.25]], linestyle='dashed', color='blue')
p += arrow(vector(locn) - vector([0,.025]),[5.05,.55*1.25+.01], color='black')
p += text('$f_{NH}(5)=m+1$', locn, color='black')

p.axes_labels(["$K_{RG}$", "$U_{NH}$"])
p.ymin(0)
p.axes_labels_size(2)
p.save('proof.pdf')
p
︡7e1270e9-01d1-4090-96d6-3cc805ba9527︡︡{"file":{"filename":"/projects/c293aefd-1fdf-4b9c-95f4-75bb77035e42/.sage/temp/compute1-us/26764/tmp_bEyZYL.svg","show":true,"uuid":"f8870b54-363a-44a8-8719-5bcb34ee8fdb"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}

︠94de0201-147b-4aba-baee-d718df580844︠
︡b8ffeab2-132b-4e21-b814-0042e4c7c0aa︡︡{"done":true}
︠8fad9964-a102-4d9a-accf-a7f6283dba88︠









